﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
 #Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=Project.zip

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Private pnlToMove As B4XView
	Private lblState As B4XView
	Private txtWidthHeight As B4XView
	Private CheckBox2 As B4XView
	Private Button2 As B4XView
	Private pnlFind As B4XView
	Private txtFind As B4XView
	Private IME2 As IME2
	Private btnFind As B4XView
	Private pnlFindContainer As B4XView
	Private pnlFindButton As B4XView
	Private pnlFindHideExpansion As B4XView
	Private btnFromLeft As B4XView
	Private btnFromTop As B4XView
	Private btnFromBottom As B4XView
	Private btnFromRight As B4XView
	Private pnlBody As B4XView
	Private Button1 As B4XView
End Sub

Public Sub Initialize
	
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
	B4XPages.SetTitle(Me, "Fun with Panels")
	IME2.Initialize("IME2")
	IME2.AddHeightChangedEvent
	#if b4a
		IME2_HeightChanged(100%y, 0)
		txtWidthHeight.Text = 40%x
	#end if
	
	Find_collaspe
	ResetArrowsOpen
End Sub

'You can see the list of page related events in the B4XPagesManager object. The event name is B4XPage.



Sub btnFromRight_Click
	If pnlToMove.Tag = "Visible" And pnlToMove.Tag <> ""  Then
		HideAnimated(pnlToMove, "right")
	Else
		SetStartPosition(pnlToMove, pnlToMove.Parent.Width, 0, txtWidthHeight.text, pnlToMove.Parent.Height)
		ShowAnimated(pnlToMove, "right")
	End If
End Sub

Sub btnFromTop_Click
	If pnlToMove.Tag = "Visible" And pnlToMove.Tag <> "" Then
		HideAnimated(pnlToMove, "top")
	Else
		SetStartPosition(pnlToMove, 0, -pnlToMove.Height, pnlToMove.Parent.width, txtWidthHeight.text)
		ShowAnimated(pnlToMove, "top")
	End If
End Sub

Sub btnFromLeft_Click
	If pnlToMove.Tag = "Visible" And pnlToMove.Tag <> ""  Then
		HideAnimated(pnlToMove, "left")
	Else
		SetStartPosition(pnlToMove, -pnlToMove.Width, 0, txtWidthHeight.text, pnlToMove.Parent.height)
		ShowAnimated(pnlToMove, "left")
	End If
End Sub

Sub btnFromBottom_Click
	If pnlToMove.Tag = "Visible" And pnlToMove.Tag <> ""  Then
		HideAnimated(pnlToMove, "bottom")
	Else
		SetStartPosition(pnlToMove, 0, pnlToMove.Parent.Height, pnlToMove.Parent.width, txtWidthHeight.text)
		ShowAnimated(pnlToMove, "bottom")
	End If
End Sub

Sub ResetArrowsOpen
	btnFromTop.Text = Chr(0xF063)
	btnFromBottom.Text = Chr(0xF062)
	btnFromLeft.text = Chr(0xF061)
	btnFromRight.Text = Chr(0xF060)
	lblState.Text = "O P E N   D I R E C T I O N"
End Sub

Sub ResetArrowsClose
	lblState.Text = "C L O S E   D I R E C T I O N"
	btnFromTop.Text = Chr(0xF062)
	btnFromBottom.Text = Chr(0xF063)
	btnFromLeft.text = Chr(0xF060)
	btnFromRight.Text = Chr(0xF061)
End Sub

Sub ShowAnimated (p As B4XView, FromEdge As String)

	Dim base As B4XView = p
	Dim newtop As Int = base.Top
	Dim newleft As Int = base.Left
	Select FromEdge.ToLowerCase
		Case "bottom"
			newtop = base.Parent.Height - base.Height
		Case "top"
			newtop = 0
		Case "left"
			newleft = 0
		Case "right"
			newleft = base.Parent.Width - base.Width
	End Select
	
	base.SetLayoutAnimated(300, newleft, newtop, base.Width, base.Height)
	base.Tag = "Visible"

	ResizePanelContents
	ResetArrowsClose
End Sub

Sub HideAnimated(p As B4XView, ToEdge As String)
	Dim base As B4XView = p
	Dim top As Int = base.Top
	Dim left As Int = base.Left
	Select ToEdge.toLowerCase
		Case "bottom"
			top = base.Parent.Height
		Case "top"
			top = -base.Height
		Case "left"
			left = -base.Width
		Case "right"
			left = base.Parent.Width
	End Select
	base.SetLayoutAnimated(300, left, top, base.Width, base.Height)
	base.Tag = "Invisible"
	ResetArrowsOpen
End Sub

Sub SetStartPosition(b4xv As B4XView, nLeft As Int, nTop As Int, nWidth As Int, nHeight As Int)
	b4xv.SetLayoutAnimated(0, nLeft, nTop, nWidth, nHeight)
End Sub

Sub ResizePanelContents
	' becuase we use setlayout to alter the panel dimenstions, the anchors wont work as expected
	Button2.Width = pnlToMove.Width - Button2.Left * 4
	CheckBox2.Left = Button2.Left + Button2.Width
End Sub

Sub Button2_Click
	#if B4A
		MsgboxAsync("panel button clicked", "Popup panel")
	#end if
End Sub

Sub CheckBox2_CheckedChange(Checked As Boolean)
	#if B4A
		MsgboxAsync($"panel checkbox clicked and the value is now ${Checked}"$, "Popup panel")
	#end if
End Sub

Sub Find_collaspe
	Dim wh As Int = pnlFindContainer.Height
	'pnlFindButton
	'pnlFindButton.Left = pnlFindContainer.width  - btnFind.Width
	pnlFindHideExpansion.Color = pnlFindContainer.Color
	txtFind.SetVisibleAnimated(1,False)
	pnlFindHideExpansion.Left = wh * 0.5
	pnlFind.SetLayoutAnimated(50, pnlFindContainer.width - (wh + 5dip), 5dip, wh - 5dip , wh - 10dip)
	pnlFindButton.SetLayoutAnimated(50, pnlFindContainer.width - (wh + 5dip), 5dip, wh - 5dip , wh - 10dip)
	btnFind.SetLayoutAnimated(50, 0, 0, wh-5dip, wh-10dip)
	
	IME2.HideKeyboard
End Sub

Sub btnFind_Click
	If pnlFind.Width > btnFind.Width Then
		Find_collaspe
	Else
		find_expand
	End If
End Sub

Sub find_expand
	Dim wh As Int = pnlFindContainer.Height
	txtFind.SetVisibleAnimated(10,True)
	txtFind.Text = ""
	pnlFind.SetLayoutAnimated(200,  5dip, pnlFind.Top, pnlFindContainer.Width - 15dip, pnlFind.Height)
	txtFind.SetLayoutAnimated(50, wh * 0.5, pnlFind.Top, pnlFindContainer.Width - wh, pnlFind.Height)
	
	txtFind.RequestFocus

End Sub

Sub Button1_Click
	Find_collaspe
End Sub

Sub txtFind_EnterPressed
	Find_collaspe
	' do something with the result
End Sub

Sub IME2_HeightChanged(NewHeight As Int, OldHeight As Int)
	pnlBody.Height =  NewHeight
	HideAnimated(pnlToMove, "bottom")
End Sub



Sub txtWidthHeight_Action
	
End Sub

Sub txtFind_Action
	
End Sub